<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

  /* start the timer on the page loading */
  /* dont change this */
  if(!isset($PAGE_TIME_START)) $PAGE_TIME_START=microtime();

  $DEBUG=0; // debug output on or off (1 is on , 0 is off)
  $SHOW_TODO=0; // set to 1 to show the message. 0 to not show them

  $adminEmail  = "you@yoursite.com"; // where rare administrative emails will go
  //-- use the above line or include your info from another file
  //-- this is useful to keep special informaiton hidden from web
  //--    accessible paths
  include("/home/userjsx/site_access/phprt_adminemail.php");

  //$SESSION_TIMEOUT=60*15; // 15 minutes - This keeps the session alive for 15 minutes longer
  $SESSION_TIMEOUT=60*60; // 60 minutes - This keeps the session alive for 60 minutes longer

  /* used for meta refresh */
  $REFRESH_TIME_SEC=2; // seconds to show a page before sending the user on

  /* Max number of times a person can log in with bad password before we turn off account */
  $MAX_BAD_PASS=3;

  # -------------------------------------------------------------------- #
  /* these are the names of the pages - change only if you change file names */
  /* there is no need to change them */
  $PAGE_INDEX        ="index.php";
  $PAGE_CREATE_TICKET="create_ticket.php";
  $PAGE_MODIFY_TICKET="modify_ticket.php";
  $PAGE_VIEW_TICKET  ="view_ticket.php";
  $PAGE_RELATES      ="ticket_relates.php";
  $PAGE_REPLICATE    ="replicate_ticket.php";
  $PAGE_MERGE        ="merge_ticket.php";
  $PAGE_ADMIN_ACCESS ="admin_access.php";
  $PAGE_EDIT_USER    ="edit_user.php";
  $PAGE_VIEW_USER    ="view_user.php";
  $PAGE_PROJ_DIST    ="project_distribution.php";
  $PAGE_GRAPHS       ="graphs.php";

  # -------------------------------------------------------------------- #
  /* all access to Mysql table names is via these defined names */
  /* there is no need to change them */

  $MYSQL_PREFIX="PHP_RT_";
  $TABLE_ACCESSTIMES       =$MYSQL_PREFIX."accesstimes";
  $TABLE_COMMENTS          =$MYSQL_PREFIX."comments";
  $TABLE_DB_INFO           =$MYSQL_PREFIX."db_info";
  $TABLE_EACH_TICKET       =$MYSQL_PREFIX."each_ticket";
  $TABLE_EVENTS            =$MYSQL_PREFIX."events";
  $TABLE_ITEM_DEPENDENCY   =$MYSQL_PREFIX."item_dependancy";
  $TABLE_ITEM_TO_PROJECT   =$MYSQL_PREFIX."item_to_project";
  $TABLE_ITEM_TYPE         =$MYSQL_PREFIX."item_type";  #admin:set
  $TABLE_ITEM_ENUMS        =$MYSQL_PREFIX."item_enums"; #admin:set
  $TABLE_PROJECT_ACCESS    =$MYSQL_PREFIX."project_access"; #admin:set
  $TABLE_PROJECT_DIST      =$MYSQL_PREFIX."project_dist";
  $TABLE_PROJECT_TEMPLATES =$MYSQL_PREFIX."project_templates";
  $TABLE_PROJECTS          =$MYSQL_PREFIX."projects";
  $TABLE_REMINDERS         =$MYSQL_PREFIX."reminders";
  $TABLE_SESSIONS          =$MYSQL_PREFIX."sessions"; /* NOT USED */
  $TABLE_STATE_RULES       =$MYSQL_PREFIX."state_rules";
  $TABLE_STATE_TRANSITIONS =$MYSQL_PREFIX."state_transitions";
  $TABLE_STATES            =$MYSQL_PREFIX."states";
  $TABLE_TICKET_DIST       =$MYSQL_PREFIX."ticket_dist";
  $TABLE_TICKET_ITEMS      =$MYSQL_PREFIX."ticket_items";
  $TABLE_TICKET_RELATIONS  =$MYSQL_PREFIX."ticket_relations";
  $TABLE_TRANSACTIONS      =$MYSQL_PREFIX."transactions";
  $TABLE_USERS             =$MYSQL_PREFIX."users";

  ## This defines your connection to your MySQL database
  $DB_HOST     ="localhost";
  $DB_TABLE    ="phprt";
  $DB_USER     ="phprt";
  $DB_PASSWORD ='-your-password-here';
  /* if you keep your password elsewhere - include the file */
  /* if you define your password info right above here don't
     use this next line */
  include("/home/userjsx/site_access/phprt_tool.php");

  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/
  /************** FROB NO FURTHER **********************/

  $MAIL_HEADER="";
  $MAIL_HEADER.="MIME-Versio: 1.0\n";
  $MAIL_HEADER.="Content-type: text/html; charset=iso-8859-1\n";
  $MAIL_HEADER.="From: PHP RT <$adminEmail>\n";

 
  /* no need to change these unless you want more user role levels */
  $PROJECT_ACCESS=array(
'admin'     =>10,
'leader'    =>15,
'manipulate'=>20,
'display'   =>30,
'none'      =>40,
);
  /* must manually keep this up to date */
  /* must have '' be none in addition to everything else*/
  $REVERSE_PROJECT_ACCESS=array(
10=>'admin',
15=>'leader',
20=>'manipulate',
30=>'display',
40=>'none',
''=>'none',
);

  /* don't change these */
  session_register("userID");
  session_register("time");
  session_register("dbAdmin");
  session_register("security");
  session_register("colorby"); // added for filtering storing
  session_register("filters"); // added for filtering storing
  session_register("sorting"); // added for sorting storing
  session_register("nocolumn"); // added for sorting storing
  session_register("LastProject"); // added for remembering the last project asked for
  session_register("FORM"); // added to remember what was requested when user session times out and then relogs in.
  session_register("FONT_SIZE"); // used to set the font size
  // session_register("TEST");

  $strIncludePrefix = "config";
  $sequence1="seq1";
  Include($strIncludePrefix."/languages.inc.php");
  Include($strIncludePrefix."/db.inc.php");
  Include($strIncludePrefix."/securityFunctions.inc.php");
  Include($strIncludePrefix."/generalFunctions.inc.php");
  Include($strIncludePrefix."/headerFunctions.inc.php");
  Include($strIncludePrefix."/userFunctions.inc.php");
  Include($strIncludePrefix."/showfull.inc.php");

  $DEBUG_POSTED=getPostedData(); // This builds a global variable called $_FORM[] - keys are posted varaible name, values are values of posted data
  Include($strIncludePrefix."/languages2.inc.php");

  header("Cache-control: private"); // enables forms to retain values when user hits 'back' button

  $PHPRT_VERSION="3.3.5"; /* this is the version of this tool */

  /* to contain any email distribution that needs to occur */
  $EMAILS_DATA=array();

?>
