<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

  include("config/global.inc.php");
  checkPermissions(1, $SESSION_TIMEOUT); // user logged in? - keep session alive...

  if ($_FORM['btnSubmit'])
  {
      if($DEBUG)print "Recieved Submit<BR>\n";
      $strUserID = validateNumber($LA['eu-userid'], $_FORM['txtUserID'], 1, 1000000, TRUE);
      $strFirstName    = validateText($LA['eu-first'], $_FORM['txtFirstName'], 2, 40, TRUE, FALSE);
      $strLastName     = validateText($LA['eu-last'], $_FORM['txtLastName'], 2, 40, TRUE, FALSE);
      $strEmail        = validateEmail($LA['eu-email'], $_FORM['txtEmail'], FALSE);
      $strPhone        = validateText($LA['eu-phone'], $_FORM['txtPhone'], 4, 25, TRUE, FALSE);
      $strPassword1    = validateText($LA['eu-pword1'], $_FORM['txtPassword1'], 6, 20, FALSE, FALSE);
      $strPassword2    = validateText($LA['eu-pword2'], $_FORM['txtPassword2'], 6, 20, FALSE, FALSE);
      $strFrameMode    = validateText($LA['eu-frame'], $_FORM['txtFrameMode'], 1, 1, FALSE, FALSE);
      $strView         = validateText($LA['eu-view'], $_FORM['txtView'], 1, 40, FALSE, FALSE);
      $strCorder       = validateText($LA['eu-corder'], $_FORM['txtCorder'], 1, 40, FALSE, FALSE);
      $strRorder       = validateText($LA['eu-rorder'], $_FORM['txtRorder'], 1, 40, FALSE, FALSE);

      /* do not allow user guest to do anything on this page */
      if(!strcmp($CURRENT_USER['GUEST'],"1"))
      {
        $strError.=$LA['eu-error1'];
      }

      if ($strError == "")
      {
           if ($strUserID!=$_SESSION['userID'])
           {
                $strError = $LA['eu-error2'];
           }
           else
           {


                $strSQL = "SELECT pswd_alpha FROM $TABLE_DB_INFO";
                $result = dbquery($strSQL);
                $row    = mysql_fetch_array($result);
                $strPassAlpha=$row['pswd_alpha'];
                if ($strPassword1 != $strPassword2)
                {
                     $strError = $LA['eu-error3'];
                }
		else if ($strPassAlpha && $strPassword1 &&
		         (!preg_match("/[\w]/",$strPassword1,$m1) ||
			 !preg_match("/[^\w]/",$strPassword1,$m2)))
		{
		  $strError.=$LA['eu-error4'];
		}
                else
                {
                     $strSQL0 = "SELECT email FROM $TABLE_USERS WHERE user_id='".$_SESSION['userID']."'";
                     $result0 = dbquery($strSQL0);
                     $row0    = mysql_fetch_array($result0);
                     $strOldEmail=$row0['email'];

                     $strSQL1 = "UPDATE $TABLE_USERS";
                     $strSQL1.= " SET first_name='$strFirstName', last_name='$strLastName', email='$strEmail', phone='$strPhone', frame_mode='$strFrameMode'";
                     $strSQL1.= " , c_order='$strCorder', r_order='$strRorder'";
                     if($strPassword1)
                     {
                        $strSQL1.=" , password='".md5($strPassword1)."'";
                        $strSQL1.=" , passworddate='".date(U)."'";
                     }
                     $strSQL1.= " WHERE user_id='".$_SESSION['userID']."'";
                     $result1 = dbquery($strSQL1);
                     $strError = $LA['eu-accout-updated'];

                     $msgBody = $LA['eu-from'].": ".makeHomeURL()."<BR>\n";
                     $msgBody.= " - ".$LA['eu-username'].": ".$CURRENT_USER['USERNAME']."<BR>\n";
                     $msgBody.= " - ".$LA['eu-name'].": $strFirstName $strLastName<BR>\n";
                     $msgBody.= " - ".$LA['eu-email'].": $strEmail<BR>\n";
                     $msgBody.= " - ".$LA['eu-phone'].": $strPhone<BR>\n";
                     if($strPassword1)
                     {
                       $msgBody.= $LA['eu-pword-changed'].": $strPassword1<BR>\n";
                     }
		     /* these are not used */
                     $msgBody.= "<BR><BR><BR>".$LA['eu-ifnot']." $adminEmail.";
                     mail($strEmail,$LA['eu-edit-subject'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);

                     if ($strEmail != $strOldEmail && $strOldEmail)
                     {
                         mail($strOldEmail, $LA['eu-edit-subject'].": ".date("m-d-Y"), $msgBody, $MAIL_HEADER);
                     }
                }
           }
      }
  } 
  else
  {
    $strUserID = validateNumber($LA['eu-userid'], $_FORM['txtUserID'], 1, 1000000, FALSE);
    if($strUserID && $strUserID<>$_SESSION['userID'])
    {
      $strError.=$LA['eu-error5'];
      $NOT_ME=true;
    }
    else
    {
      $NOT_ME=false;
      $strUserID=$_SESSION['userID'];
    }
  }
  if(!$strError)
  {
$strOptIn  = validateNumber($LA['eu-optin'], $_FORM['txtIn'], 1, 1000000, FALSE);
$strOptOut = validateNumber($LA['eu-optout'], $_FORM['txtOut'], 1, 1000000, FALSE);
if($strOptOut)
{
  $strSQL = "SELECT * FROM $TABLE_PROJECT_DIST WHERE dist_id='$strOptOut'";
  $result = dbquery($strSQL);
  $row    = mysql_fetch_array($result);

  $strSQL = "INSERT $TABLE_PROJECT_DIST";
  $strSQL.= " SET";
  $strSQL.= "  project_id='".$row['project_id']."'";
  if($row['event_id'])
    $strSQL.= "  , event_id='".$row['event_id']."'";
  else
    $strSQL.= "  , event_id=NULL";
  $strSQL.= "  , user_id='".$CURRENT_USER['ID']."'";
  if($row['rule_id'])
    $strSQL.= "  , rule_id='".$row['rule_id']."'";
  else
    $strSQL.= "  , rule_id=NULL";
  if($row['stran_id'])
    $strSQL.= "  , stran_id='".$row['stran_id']."'";
  else
    $strSQL.= "  , stran_id=NULL";
  $strSQL.= " , role='NEVER'";
  //echo "Q2:<DIR>$strSQL</DIR>";
  $result = dbquery($strSQL);
}
else
{
  //echo "sIN:$strOptIn<BR>";
  $strSQL = "DELETE FROM $TABLE_PROJECT_DIST WHERE dist_id='$strOptIn' AND user_id='".$CURRENT_USER['ID']."'";
  $result = dbquery($strSQL);
}
  } // end of the opt-in and opt-out



// start person overriding
if(!$strError)
{
$strDproject = validateNumber($LA['eu-dproject'], $_FORM['txtDproject'], 1, 1000000, FALSE);
$strAddD     = validateNumber($LA['eu-dadd'],     $_FORM['addD'], 1, 1000000, FALSE);
$strDevent   = validateNumber($LA['eu-devent'],   $_FORM['txtDevent'], 1, 1000000, FALSE);
$strDitem    = validateNumber($LA['eu-ditem'],    $_FORM['txtDitem'], 1, 1000000, FALSE);
$strDstate   = validateNumber($LA['eu-dstate'],   $_FORM['txtDstate'], 1, 1000000, FALSE);
$strDemail   = validateNumber($LA['eu-demail'],   $_FORM['txtDemail'], 1, 1000000, FALSE);
// do we have access to this project?
$sQ2="SELECT level";
$sQ2.=" FROM $TABLE_PROJECT_ACCESS";
$sQ2.=" WHERE project_id='$strDproject'";
$sQ2.="   AND user_id='".$CURRENT_USER['ID']."'";
$sQ2.="   AND level<='".$PROJECT_ACCESS['display']."'";
$rs2= dbquery($sQ2);
if($rw2= mysql_fetch_array($rs2))
{
  if($strAddD)
  {
    if($strDevent)
    {
      if($strDemail)
      {
        echo $LA['eu-adding-event'];
$sQ ="INSERT INTO $TABLE_PROJECT_DIST";
$sQ.=" SET project_id='$strDproject'";
$sQ.=" , event_id='$strDevent'";
$sQ.=" ,role='$strDemail'";
$sQ.=" ,user_id='".$CURRENT_USER['ID']."'";
$rs= dbquery($sQ);
      }
      else
      {
        $strError.=$LA['eu-error6'];
      }
    }
    else if($strDitem)
    {
      if($strDemail)
      {
        echo $LA['eu-adding-item'];
$sQ ="INSERT INTO $TABLE_PROJECT_DIST";
$sQ.=" SET project_id='$strDproject'";
$sQ.=" , rule_id='$strDitem'";
$sQ.=" ,role='$strDemail'";
$sQ.=" ,user_id='".$CURRENT_USER['ID']."'";
$rs= dbquery($sQ);
      }
      else
      {
        $strError.=$LA['eu-error-7'];
      }
    }
    else if($strDstate)
    {
      if($strDemail)
      {
        echo $LA['eu-adding-state'];
$sQ ="INSERT INTO $TABLE_PROJECT_DIST";
$sQ.=" SET project_id='$strDproject'";
$sQ.=" , stran_id='$strDstate'";
$sQ.=" ,role='$strDemail'";
$sQ.=" ,user_id='".$CURRENT_USER['ID']."'";
$rs= dbquery($sQ);
      }
      else
      {
        $strError.=$LA['eu-error8'];
      }
    }
    else
    {
      $strErr.=$LA['eu-error9'];
    }
  }
  else
  {
    $strError.=$LA['eu-error10'];
  }
}
}
// end person overriding



  $strSQL2 = "SELECT * FROM $TABLE_USERS WHERE user_id='$strUserID'";
  $result2= dbquery($strSQL2);
  $row2= mysql_fetch_array($result2);

  $strUsername       = $row2['username'];
  $strFirstName      = $row2['first_name'];
  $strLastName       = $row2['last_name'];
  $strEmail          = $row2['email'];
  $strPhone          = $row2['phone'];
  $strPassworddate   = $row2['passworddate'];
  $strFrameMode      = $row2['frame_mode']; if($strFrameMode)$SEL_YES="SELECTED";else $SEL_NO="SELECTED";
  $strView           = $row2['view'];
  $strCorder         = $row2['c_order'];
  $strRorder         = $row2['r_order'];
  $strAccountCreated = $row2['account_create_date'];
  $strDBAdmin        = $row2['db_admin'];
  $strSuccBadPass    = $row2['succ_badpass'];
  $strNumBadPass     = $row2['num_badpass'];
  $strNumLogouts     = $row2['num_logouts'];
  $strNumLogins      = $row2['num_logins'];
  $strLastBadPass    = $row2['last_badpass'];
  $strLastLogout     = $row2['last_logout'];
  $strLastLogin      = $row2['last_login'];

  if($NOT_ME)
  {
    writeHeader($LA['eu-profile-page'].": $strLastName, $strFirstName");
  }
  else
  {
    writeHeader($LA['eu-your-profile']);
  }
  declareError(TRUE);
?>
<script>
function chkpas()
{
  ret=true;
  f=document.form1;
  p1=f.txtPassword1.value;
  p2=f.txtPassword2.value;
  if(p1!=p2){alert("<?=$LA['eu-pwords-match'];?>.");ret=false;}
  return ret;
}
</script>
<form onsubmit='return chkpas()' class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtUserID" value="<?=$_SESSION['userID'];?>">
  <br><table class=forms border='0' cellpadding='2'>
    <tr><td ><?=$LA['eu-username'];?>:</td><td><?=$strUsername;?></td></tr>
<?
if($strDBAdmin)
{
print "   <tr><td >".$LA['eu-ur-dbadmin'].":</td><td>Yes</td></tr>";
}
?>
    <tr><td ><?=$LA['eu-account-created'];?>:</td><td><?=printDate2($strAccountCreated);?></td></tr>
    <tr><td ><?=$LA['eu-word-change-date'];?>:</td><td><?=printDate2($strPassworddate);?></td></tr>
    <tr><td ><?=$LA['eu-last-login'];?>:</td><td><?=printDate2($strLastLogin);?> - <?=$LA['eu-total'];?> (<?=$strNumLogins;?>)</td></tr>
    <tr><td ><?=$LA['eu-last-logout'];?>:</td><td><?=printDate2($strLastLogout);?> - <?=$LA['eu-total'];?> (<?=$strNumLogouts;?>)</td></tr>
    <tr><td ><?=$LA['eu-last-bpass'];?>:</td><td><?=printDate2($strLastBadPass);?>  - <?=$LA['eu-total'];?> (<?=$strSuccBadPass;?>/<?=$strNumBadPass;?>)</td></tr>
<?if(!$NOT_ME){?>
    <tr>
      <td ><?=$LA['eu-first'];?>:</td>
      <td ><input class=forms type="text" name="txtFirstName" value="<?echo $strFirstName;?>" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['eu-last'];?>:</td>
      <td ><input class=forms type="text" name="txtLastName" value="<?echo $strLastName;?>" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['eu-email'];?>:</td>
      <td ><input class=forms type="text" name="txtEmail" value="<?echo $strEmail;?>" size="40" maxlength="50"></td>
    </tr>
    <tr>
      <td ><?=$LA['eu-pword'];?>:</td><td><input type=password class=forms name="txtPassword1" size="40" maxlength="20"></td>
    </tr>
    <tr>
      <td ><?=$LA['eu-vpword'];?>:</td><td><input type=password class=forms name="txtPassword2" size="40" maxlength="20"></td>
    </tr>
    <tr> <!-- does not show up anywhere -->
      <td ><?=$LA['eu-phone'];?>:</td><td><input type=text class=forms name="txtPhone" size="20" value="<?=$strPhone;?>" maxlength="20"></td>
    </tr>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['eu-commit'];?>" name="btnSubmit">
      <input class=form_button type="reset" value="<?=$LA['eu-reset'];?>" name="reset">
    </td></tr>
<?}else{?>
    <tr> <td ><?=$LA['eu-first'];?>:</td> <td ><?=$strFirstName;?></td> </tr>
    <tr> <td ><?=$LA['eu-last'];?>:</td> <td ><?=$strLastName;?></td> </tr>
    <tr> <td ><?=$LA['eu-email'];?>:</td> <td ><?=$strEmail;?></td> </tr>
    <tr> <td ><?=$LA['eu-phone'];?>:</td><td><?=$strPhone;?></td> </tr>
<?}?>
  </table><br>
</form>

<form class=forms method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<table class=bckgnd border='0' cellspacing=1 cellpadding='2'>
<tr class=warn2><td colspan=7 align=center><?=$LA['eu-proj-dist-title'];?></td></tr>
<tr class=rowh>
<td align=center><?=$LA['eu-dist-project'];?></td>
<td align=center><?=$LA['eu-dist-event'];?></td>
<td align=center><?=$LA['eu-dist-dataitem'];?></td>
<td align=center><?=$LA['eu-dist-state'];?></td>
<td align=center><?=$LA['eu-dist-email'];?></td>
<td align=center><?=$LA['eu-dist-back'];?></td>
<td align=center><?=$LA['eu-dist-override'];?></td>
</tr>
<?
$strSQLt = "SELECT *, A.rule_id as arule_id, A.stran_id as astran_id,A.role as a_role,PU.role as pu_role,F.name as fname, T.name as tname, P.project_name, PU.dist_id as pudist, A.dist_id as dist";
$strSQLt.= " FROM ($TABLE_PROJECT_DIST AS A";
$strSQLt.= " , $TABLE_PROJECTS AS P)";
$strSQLt.= " LEFT JOIN $TABLE_EVENTS AS E ON A.event_id=E.event_id";
$strSQLt.= " LEFT JOIN $TABLE_ITEM_TO_PROJECT AS I ON A.rule_id=I.rule_id";
$strSQLt.= " LEFT JOIN $TABLE_STATE_TRANSITIONS AS S ON A.stran_id=S.stran_id";
$strSQLt.= " LEFT JOIN $TABLE_STATES AS F ON S.from_state_id=F.state_id";
$strSQLt.= " LEFT JOIN $TABLE_STATES AS T ON S.to_state_id=T.state_id";
$strSQLt.= " LEFT JOIN $TABLE_PROJECT_DIST AS PU";
$strSQLt.= "   ON PU.user_id='".$CURRENT_USER['ID']."'";
$strSQLt.= "   AND PU.project_id=A.project_id";
$strSQLt.= "   AND (PU.event_id=A.event_id";
$strSQLt.= "        OR PU.rule_id=A.rule_id";
$strSQLt.= "        OR PU.stran_id=A.stran_id)";
$strSQLt.= " WHERE P.project_id=A.project_id";
$strSQLt.= " AND A.user_id is NULL"; // we don't care about user settings on this admin page
$strSQLt.= " ORDER BY P.project_name,tname,fname,label,event_type";
//echo "Q:<DIR>$strSQLt</DIR>";
$resultt= dbquery($strSQLt);
$r=0;
$last="";
while($rowt= mysql_fetch_array($resultt))
{
  $strPName    = $rowt['project_name'];
  $strDistID   = $rowt['dist'];
  $strPUDistID = $rowt['pudist'];
  $strEventID  = $rowt['event_id']; $strEventType=$rowt['event_type'];
  $strRuleID   = $rowt['arule_id'];  $strRuleLabel=$rowt['label'];
  $strSTranID  = $rowt['astran_id']; 
  if($strSTranID)$strStateLabel=$rowt['fname']." to ".$rowt['tname'];
  $strStateLabel=($strSTranID)?$rowt['fname']." to ".$rowt['tname']:"";
  $strRole     = $rowt['a_role'];
  $strPURole     = $rowt['pu_role'];
  if($last<>$strPName)
  {
    $r=($r+1)%2;
    $last=$strPName;
  }
  if($strPUDistID)
    echo "<tr class=rowxx>"; // grey out the non-active rows
  else
    echo "<tr class=row$r>";
  echo "<td>$strPName</td>";
  echo "<td>$strEventType</td>";
  echo "<td>$strRuleLabel</td>";
  echo "<td>$strStateLabel</td>";
  echo "<td>$strRole</td>";
  if(!$strPUDistID)
  {
    echo "<td align=center>-</td>";
    echo "<td align=center><input type=submit class=form_button name='txtOut' value='$strDistID'></td>";
  }
  else
  {
    echo "<td align=center><input type=submit class=form_button name='txtIn' value='$strPUDistID'></td>";
    echo "<td align=center>-</td>";
  }
  echo "</tr>";
}
?>
</table>
</form>
<BR>
<form class=forms method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<table class=bckgnd border='0' cellspacing=1 cellpadding='2'>
<tr class=warn2><td colspan=6 align=center><?=$LA['eu-idist-tile'];?></td></tr>
<tr class=rowh>
<td align=center><?=$LA['eu-idist-project'];?></td>
<td align=center><?=$LA['eu-idist-event'];?></td>
<td align=center><?=$LA['eu-idist-dataitem'];?></td>
<td align=center><?=$LA['eu-idist-state'];?></td>
<td align=center><?=$LA['eu-idist-email'];?></td>
<td align=center><?=$LA['eu-idist-deladd'];?></td>
</td>

<?
// find all distribution rules that this user has added that do not
// counter a project rule, then list them here so the user can
// see them, and also have a chance to remove them.
$sQ ="SELECT A.dist_id, A.role, C.project_name, D.event_type, E.label, A.stran_id, G.name as fname, H.name as tname";
$sQ.="";
$sQ.=" FROM";
$sQ.="    ($TABLE_PROJECT_DIST AS A";
$sQ.="  , $TABLE_PROJECT_DIST AS B";
$sQ.="  , $TABLE_PROJECTS AS C)";
$sQ.="  LEFT JOIN $TABLE_EVENTS AS D ON D.event_id=A.event_id";
$sQ.="  LEFT JOIN $TABLE_ITEM_TO_PROJECT AS E ON E.rule_id=A.rule_id";
$sQ.="  LEFT JOIN $TABLE_STATE_TRANSITIONS AS F ON F.stran_id=A.stran_id";
$sQ.="  LEFT JOIN $TABLE_STATES AS G ON G.state_id=F.from_state_id";
$sQ.="  LEFT JOIN $TABLE_STATES AS H ON H.state_id=F.to_state_id";
$sQ.=" WHERE";
$sQ.="       A.user_id='".$CURRENT_USER['ID']."'";
$sQ.="   AND B.user_id is NULL";
$sQ.="   AND A.project_id=C.project_id";
$sQ.="   AND A.role<>'NEVER'";
$sQ.="   GROUP BY A.dist_id";
$res= dbquery($sQ);
$r=0;
$l="";
while($row= mysql_fetch_array($res))
{
  if(strcmp($l,$row['project_name']))
  {
    $r=($r+1)%2;
    $l=$row['project_name'];
  }
  echo "<tr class=row$r>";
  echo "<td>".$row['project_name']."</td>";
  echo "<td align=center>".$row['event_type']."</td>";
  echo "<td align=center>".$row['label']."</td>";
  if($row['stran_id'])
    echo "<td align=center>".$row['fname']." to ".$row['tname']."</td>";
  else
    echo "<td>&nbsp;</td>";
  echo "<td align=center>".$row['role']."</td>";
  //echo "<td><input class=form_button type=submit value='".$row['dist_id']."' name='delmydist'></td>";
  echo "<td align=center><input class=form_button type=submit value='".$row['dist_id']."' name='txtIn'></td>";
  echo "</tr>";
}
?>




<tr class=warn>
 <td>
  <select name='txtDproject' class=forms>
<?
  $sQ ="SELECT A.project_id, B.project_name";
  $sQ.=" FROM";
  $sQ.="     ($TABLE_PROJECT_ACCESS AS A";
  $sQ.="   , $TABLE_PROJECTS AS B)";
  $sQ.=" WHERE";
  $sQ.="       A.user_id='".$CURRENT_USER['ID']."'";
  $sQ.="   AND A.level<='".$PROJECT_ACCESS['display']."'";
  $sQ.="   AND A.project_id=B.project_id";
  echo "sQ:<DIR>$sQ</DIR>";
  $res= dbquery($sQ);
  while($rw= mysql_fetch_array($res))
  {
    echo "<option value='".$rw['project_id']."'>".$rw['project_name']."</option>";
  }
?>
  </select>
 </td>
 <td>
  <select name='txtDevent' class=forms>
    <option value=''><?=$LA['eu-none'];?></option>
<?
  $sQ ="SELECT event_id, event_type";
  $sQ.=" FROM";
  $sQ.="     $TABLE_EVENTS";
  $sQ.=" ORDER BY event_type";
  echo "sQ:<DIR>$sQ</DIR>";
  $res= dbquery($sQ);
  while($rw= mysql_fetch_array($res))
  {
    echo "<option value='".$rw['event_id']."'>".$rw['event_type']."</option>";
  }
?>
  </select>
 </td>
 <td>
  <select name='txtDitem' class=forms>
    <option value=''><?=$LA['eu-none'];?></option>
<?
  $sQ ="SELECT A.rule_id, A.label, C.project_abbr";
  $sQ.=" FROM";
  $sQ.="     ($TABLE_ITEM_TO_PROJECT AS A";
  $sQ.="   , $TABLE_PROJECT_ACCESS AS B";
  $sQ.="   , $TABLE_PROJECTS AS C)";
  $sQ.=" WHERE";
  $sQ.="       B.user_id='".$CURRENT_USER['ID']."'";
  $sQ.="   AND B.level<='".$PROJECT_ACCESS['display']."'";
  $sQ.="   AND A.project_id=B.project_id";
  $sQ.="   AND B.project_id=C.project_id";
  $sQ.=" ORDER BY C.project_abbr, A.label";
  echo "sQ:<DIR>$sQ</DIR>";
  $res= dbquery($sQ);
  while($rw= mysql_fetch_array($res))
  {
    echo "<option value='".$rw['rule_id']."'>(".$rw['project_abbr'].") ".$rw['label']."</option>";
  }
?>
  </select>
 </td>
 <td>
  <select name='txtDstate' class=forms>
    <option value=''><?=$LA['eu-none'];?></option>
<?
  $sQ ="SELECT A.stran_id, D.name as fname, E.name as tname, C.project_abbr";
  $sQ.=" FROM";
  $sQ.="     ($TABLE_STATE_TRANSITIONS AS A";
  $sQ.="   , $TABLE_PROJECT_ACCESS AS B";
  $sQ.="   , $TABLE_PROJECTS AS C";
  $sQ.="   , $TABLE_STATES AS D";
  $sQ.="   , $TABLE_STATES AS E)";
  $sQ.=" WHERE";
  $sQ.="       B.user_id='".$CURRENT_USER['ID']."'";
  $sQ.="   AND B.level<='".$PROJECT_ACCESS['display']."'";
  $sQ.="   AND B.project_id=C.project_id";
  $sQ.="   AND A.from_state_id=D.state_id";
  $sQ.="   AND D.project_id=C.project_id";
  $sQ.="   AND A.to_state_id=E.state_id";
  $sQ.="   AND E.project_id=C.project_id";
  $sQ.=" ORDER BY C.project_abbr, D.name, E.name";
  echo "sQ:<DIR>$sQ</DIR>";
  $res= dbquery($sQ);
  while($rw= mysql_fetch_array($res))
  {
    echo "<option value='".$rw['stran_id']."'>(".$rw['project_abbr'].") ".$rw['fname']." - ".$rw['tname']."</option>";
  }
?>
  </select>
 </td>
 <td>
  <select name='txtDemail' class=forms>
    <option value='ALWAYS'><?=$LA['eu-always'];?></option>
    <option value='OWNER'><?=$LA['eu-owner'];?></option>
  </select>
 </td>
 <td align=center>
   <input type=submit value='<?=$LA['eu-add'];?>' name='addD' class=form_button>
 </td>
</tr>
</table>
</form>
<?
  writeFooter();
?>
