<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

Include("config/global.inc.php");
checkPermissions(1, $SESSION_TIMEOUT); // if not logged in, or session has timed out...

/* these are numbers...*/
$ProjectID = validateNumber($LA['gr-projectid'],   $_FORM['txtProjectID'],    1, 1000000, FALSE);

writeHeader();
declareError(TRUE);

$GRAPHS=array();$i=0;
$GRAPHS[$i++]="graph-created-v-closed.php";
$GRAPHS[$i++]="graph-open-v-time.php";
$GRAPHS[$i++]="graph-pie-states.php";
$GRAPHS[$i++]="graph-pie-active-states.php";

if($ProjectID)
{
  /* show small version of all defined graphs */
  $t="Click to view larger";
  for($j=0;$j<$i;$j++)
  {
    $G=$GRAPHS[$j];
    echo "<a title='$t' href='show.php?graph=$G&txt_project=$ProjectID'>";
    echo "<img border=0 src=$G?txt_project=$ProjectID>";
    echo "</a> ";
  }
}
else /* no project specified */
{
  echo "You must first select a project to see graphs";
}

/* always show the option to swich which project to see graphs for */
echo "<center><BR>";
  if(isset($CURRENT_USER['ID']) && $CURRENT_USER['ID'])
  {
    $strSQL ="SELECT *";
    $strSQL.=" FROM $TABLE_PROJECTS AS A";
    $strSQL.=" , $TABLE_PROJECT_ACCESS AS B";
    $strSQL.=" WHERE A.project_id=B.project_id";
    $strSQL.=" AND B.user_id='".$CURRENT_USER['ID']."'";
    $strSQL.=" AND B.level <= '".$PROJECT_ACCESS['display']."'";
    $strSQL.=" ORDER BY project_name";
    $result=dbquery($strSQL);
    $_temp="";
    $numFound=0;
    while($row=mysql_fetch_array($result))
    {
      $numFound++;
      $ck = strcmp($_SESSION['LastProject'],$row['project_id'])?"":" SELECTED ";
      $_temp.="<option $ck value='".$row['project_id']."'>".$row['project_name']."</option>";
    }
    //print "<tr><td valign=middle class=top_links>";
    if($numFound>1)
    {
      print "<form method=GET name='projects' action='graphs.php'>";
      print "<input type=submit name='view' class=form_button value=\"".$LA['gr-viewgraph']."\">&nbsp;";
      print "<select name='txtProjectID' class=forms>";
      print $_temp;
      print "</select>";
      print "</form>";
    }
    else
    {
      echo "You don't have access to any projects.";
    }
  }

echo "</center>";

writeFooter();
?>
